VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} Frm_Muecke1982 
   Caption         =   "Pflege von Stcklistenwerten"
   ClientHeight    =   7560
   ClientLeft      =   120
   ClientTop       =   470
   ClientWidth     =   6540
   OleObjectBlob   =   "Frm_Muecke1982.frx":0000
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "Frm_Muecke1982"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private oApp As Inventor.Application
Private oDoc As Document

Private Sub Btn_Cancel_Click()
    Me.Hide
    Unload Me
End Sub

Private Sub Btn_Reset_Click()
    Call Refresh_Form
End Sub

Private Sub Btn_Save_Click()
    Me.Hide
    
    'TODO - Write Properties
    WriteProps
    
    Unload Me
End Sub

Private Sub TBox_Bauteilnummer_Change()

End Sub

Private Sub UserForm_Initialize()
    ' die Initialisierung der UserForm
    Set oApp = ThisApplication
    
    If oApp.Documents.count = 0 Then Exit Sub
    If Not oApp.ActiveDocumentType = kAssemblyDocumentObject And _
       Not oApp.ActiveDocumentType = kPartDocumentObject Then Exit Sub
       
    Set oDoc = oApp.ActiveDocument
    
    Call Refresh_Form
End Sub

Private Sub Refresh_Form()
    ' die Sub befllt initial die Form
    ' sie kann auch fr ein Reset der Eingaben genutzt werden
    
    ' aktuelle Stcklistenstruktur des Dokumentes
    Dim oBOMStructure As BOMStructureEnum
    oBOMStructure = oDoc.ComponentDefinition.BOMStructure
    
    Dim sSelectedItemName As String
    sSelectedItemName = GetBOMStructureName(oBOMStructure)
    
    ' hier Stcklistenstrukturliste erstellen und die vorhandenen Werte aus den iProps auslesen
    With CBox_BOMStructure
        .AddItem "Normal"
        .AddItem "Unteilbar"
        .AddItem "Gekauft"
        .AddItem "Phantom"
        .AddItem "Referenz"
    End With
        
    If Not sSelectedItemName = "" Then
        CBox_BOMStructure.Text = sSelectedItemName
    End If
    
    Call ReadProps
End Sub


Private Sub CBox_BOMStructure_Change()
    Dim oBOMStructure As BOMStructureEnum
    oBOMStructure = GetBOMStructureEnum(CBox_BOMStructure.Text)
    
    If Not oDoc.ComponentDefinition.BOMStructure = oBOMStructure Then
        oDoc.ComponentDefinition.BOMStructure = oBOMStructure
    End If
End Sub

Private Sub ReadProps()
    TBox_Bauteilnummer.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Part Number").Value
    TBox_Bestandsnummer.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Stock Number").Value
    TBox_Bezeichnung.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Description").Value
    TBox_Kosten.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Cost").Value
    TBox_Zulieferer.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Vendor").Value
    TBox_URL.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Catalog Web Link").Value
End Sub
Private Sub WriteProps()
    ' die Props sollen nur bei abweichenden Werten neu geschrieben werden
    If Not oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Part Number").Value = TBox_Bauteilnummer.Text Then oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Part Number").Value = TBox_Bauteilnummer.Text
    If Not oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Stock Number").Value = TBox_Bestandsnummer.Text Then oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Stock Number").Value = TBox_Bestandsnummer.Text
    If Not oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Description").Value = TBox_Bezeichnung.Text Then oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Description").Value = TBox_Bezeichnung.Text
    If Not oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Cost").Value = TBox_Kosten.Text Then oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Cost").Value = TBox_Kosten.Text
    If Not oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Vendor").Value = TBox_Zulieferer.Text Then oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Vendor").Value = TBox_Zulieferer.Text
    If Not oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Catalog Web Link").Value = TBox_URL.Text Then oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Catalog Web Link").Value = TBox_URL.Text
End Sub
Private Function GetBOMStructureEnum(ByVal sBOMStructureName As String) As BOMStructureEnum
    Select Case sBOMStructureName
        Case "Normal": GetBOMStructureEnum = BOMStructureEnum.kNormalBOMStructure
        Case "Unteilbar": GetBOMStructureEnum = BOMStructureEnum.kInseparableBOMStructure
        Case "Gekauft": GetBOMStructureEnum = BOMStructureEnum.kPurchasedBOMStructure
        Case "Phantom": GetBOMStructureEnum = BOMStructureEnum.kPhantomBOMStructure
        Case "Referenz": GetBOMStructureEnum = BOMStructureEnum.kReferenceBOMStructure
    End Select
End Function

Private Function GetBOMStructureName(ByVal oBOMStructureEnum As BOMStructureEnum) As String
    Select Case oBOMStructureEnum
        Case BOMStructureEnum.kNormalBOMStructure: GetBOMStructureName = "Normal"
        Case BOMStructureEnum.kInseparableBOMStructure: GetBOMStructureName = "Unteilbar"
        Case BOMStructureEnum.kPurchasedBOMStructure: GetBOMStructureName = "Gekauft"
        Case BOMStructureEnum.kPhantomBOMStructure: GetBOMStructureName = "Phantom"
        Case BOMStructureEnum.kReferenceBOMStructure: GetBOMStructureName = "Referenz"
    End Select
End Function

